#define BOOST_TEST_MODULE "testcase for Mic class and Mic1 class"
#define BOOST_TEST_DYN_LINK
#include "common.hpp"

#include <boost/test/unit_test.hpp>

#include <string>
#include <boost/shared_ptr.hpp>
#include <harkio2/harkconfig/Mic.hpp>
#include "rangecheck.hpp"
using namespace boost;
using namespace std;

typedef boost::shared_ptr<harkio2::harkconfig::Mic> mp;
typedef boost::shared_ptr<harkio2::harkconfig::Mic1> mp1;

BOOST_AUTO_TEST_CASE(versioning_test)
{
    mp m0(new harkio2::harkconfig::Mic1());
    BOOST_CHECK_EQUAL(m0->GetVersion(), 1);
}

BOOST_AUTO_TEST_CASE(getter_setter_test)
{
    mp m0(new harkio2::harkconfig::Mic1());

    BOOST_CHECK_EQUAL(m0->GetVersion(), 1);

    mp1 m1 = dynamic_pointer_cast<harkio2::harkconfig::Mic1>(m0);

    BOOST_CHECK(m1 != 0);

    if (m1 != 0)
    {
        BOOST_CHECK_EQUAL(m1->GetVersion(), 1);

        BOOST_CHECK_THROW(m1->GetMicIndex(), harkio2::NotInitialized);
        BOOST_CHECK_THROW(m1->GetComment(), harkio2::NotInitialized);

        m1->SetMicIndex(3);
        m1->SetPosition(harkio2::MakePositionFromVector<float>(harkio2::Vector3<float>(1, 2, 3)));
        m1->SetComment(u8"マイク情報");

        BOOST_CHECK_NO_THROW(m1->GetMicIndex());
        BOOST_CHECK_NO_THROW(m1->GetComment());
        BOOST_CHECK_EQUAL(m1->GetMicIndex(), 3);
        BOOST_CHECK(rangecheck::CheckRange<float>(m1->GetPosition().GetUnitVector(), harkio2::Normalize(harkio2::Vector3<float>(1, 2, 3)), 0.01));

    }
}

